//<<AICUBE_USER_HEADER_REMARK_BEGIN>>
////////////////////////////////////////
// ڴûļͷ˵Ϣ
// ļ: i2c.c
// ļ: 
// ļ汾: V1.0
// ޸ļ¼:
//   1. (2025-05-23) ļ
////////////////////////////////////////
//<<AICUBE_USER_HEADER_REMARK_END>>


#include "config.h"


//<<AICUBE_USER_INCLUDE_BEGIN>>
// ڴûͷļ
//<<AICUBE_USER_INCLUDE_END>>


//<<AICUBE_USER_GLOBAL_DEFINE_BEGIN>>
// ڴûȫֱ塢û궨Լ
//<<AICUBE_USER_GLOBAL_DEFINE_END>>


BOOL fI2CMasterBusy;                    //I2Cģʽæ־

////////////////////////////////////////
// I2CжϷ
// ڲ: 
// : 
////////////////////////////////////////
void I2C_ISR(void) interrupt I2C_VECTOR
{
    //<<AICUBE_USER_I2C_ISR_CODE1_BEGIN>>
    // ڴжϺû
    if (I2C_CheckMasterFlag())          //жI2Cж
    {
        I2C_ClearMasterFlag();          //I2Cжϱ־
        fI2CMasterBusy = 0;             //ģʽæ־λ
    }
    //<<AICUBE_USER_I2C_ISR_CODE1_END>>
}

////////////////////////////////////////
// I2Cʼ
// ڲ: 
// : 
////////////////////////////////////////
void I2C_Init(void)
{
    I2C_SwitchP3332();                  //ѡI2Cݿ: SCL(P3.2), SDA(P3.3)

    I2C_MasterMode();                   //I2CΪģʽ
    I2C_SetClockDivider(23);            //I2CΪģʽʱ

    I2C_SetIntPriority(0);              //жΪȼ
    I2C_EnableMasterInt();              //I2Cģʽж
    fI2CMasterBusy = 0;                 //ģʽæ־λ

    I2C_Enable();                       //ʹI2C

    //<<AICUBE_USER_I2C_INITIAL_BEGIN>>
    // ڴûʼ
    //<<AICUBE_USER_I2C_INITIAL_END>>
}

////////////////////////////////////////
// ģʽȴ
// ڲ: 
// : 
////////////////////////////////////////
void I2C_MasterWait(void)
{
    while (fI2CMasterBusy);             //ȴæ־Ϊ0
}

////////////////////////////////////////
// ģʽʼź
// ڲ: 
// : 
////////////////////////////////////////
void I2C_MasterStart(void)
{
    I2C_Start();                        //ģʽʼ
    fI2CMasterBusy = 1;                 //æ־
    I2C_MasterWait();                   //ȴ
}

////////////////////////////////////////
// ģʽֹͣź
// ڲ: 
// : 
////////////////////////////////////////
void I2C_MasterStop(void)
{
    I2C_Stop();                         //ģʽֹͣ
    fI2CMasterBusy = 1;                 //æ־
    I2C_MasterWait();                   //ȴ
}

////////////////////////////////////////
// ģʽ1ֽ
// ڲ: dat (͵ֽ)
// : 0   (յӦźΪACK)
//           1   (յӦźΪNAK)
////////////////////////////////////////
BOOL I2C_MasterSendByte(uint8_t dat)
{
    I2C_WriteData(dat);                 //дI2CݼĴ
    I2C_SendData();                     //ģʽд
    fI2CMasterBusy = 1;                 //æ־
    I2C_MasterWait();                   //ȴ
    I2C_RecvACK();                      //ģʽӦ
    fI2CMasterBusy = 1;                 //æ־
    I2C_MasterWait();                   //ȴ

    return I2C_MasterReadACK();         //ȡӦź
}

////////////////////////////////////////
// ģʽ1ֽ
// ڲ: ack (͵Ӧź)
// :     (յֽ)
////////////////////////////////////////
uint8_t I2C_MasterReadByte(BOOL ack)
{
    uint8_t dat;

    I2C_RecvData();                     //ģʽ
    fI2CMasterBusy = 1;                 //æ־
    I2C_MasterWait();                   //ȴ
    dat = I2C_ReadData();               //ȡյ
    if (!ack)
        I2C_MasterSetACK();             //ACKдĴ
    else
        I2C_MasterSetNAK();             //NAKдĴ
    I2C_SendACK();                      //ģʽӦ
    fI2CMasterBusy = 1;                 //æ־
    I2C_MasterWait();                   //ȴ

    return dat;                         //ؽյ
}


//<<AICUBE_USER_FUNCTION_IMPLEMENT_BEGIN>>
// ڴûʵִ
#define SLAW        0xA0
#define SLAR        0xA1

void WriteNbyte(u8 addr, u8 *p, u8 number)  /*  WordAddress,First Data Address,Byte lenth   */
{
    I2C_MasterStart();                                //ʼ
    I2C_MasterSendByte(SLAW);                         //豸ַ+д
    I2C_MasterSendByte(addr);                         //ʹ洢ַ
    do
    {
        I2C_MasterSendByte(*p++);
    }
    while(--number);
    I2C_MasterStop();                                 //ֹͣ
}

void ReadNbyte(u8 addr, u8 *p, u8 number)   /*  WordAddress,First Data Address,Byte lenth   */
{
    I2C_MasterStart();                                //ʼ
    I2C_MasterSendByte(SLAW);                         //豸ַ+д
    I2C_MasterSendByte(addr);                         //ʹ洢ַ
    I2C_MasterStart();                                //ʼ
    I2C_MasterSendByte(SLAR);                         //豸ַ+
    do
    {
        *p = I2C_MasterReadByte(number == 1);
        p++;
    }
    while(--number);
    I2C_MasterStop();                                 //ֹͣ
}
//<<AICUBE_USER_FUNCTION_IMPLEMENT_END>>


